## net.i2p.data
Class SessionKey

    java.lang.Object
      net.i2p.data.DataStructureImpl
          net.i2p.data.SessionKey

All Implemented Interfaces:
  DataStructure

public class SessionKey
extends DataStructureImpl

Defines the SessionKey as defined by the I2P data structure spec. A session key is 32byte Integer.

Author:
  jrandom

Field Summary
`static SessionKey` `INVALID_KEY`
`static int` `KEYSIZE_BYTES`

Constructor Summary
`SessionKey()`
`SessionKey(byte[] data)`

Method Summary
`boolean` `equals(java.lang.Object obj)`
`byte[]` `getData()`
`java.lang.Object` `getPreparedKey()` retrieve an internal representation of the session key, as known by the AES engine used.
`int` `hashCode()`
`void` `readBytes(java.io.InputStream in)` Load up the current object with data from the given stream.
`void` `setData(byte[] data)` caveat: this method isn't synchronized with the preparedKey, so don't try to *change* the key data after already doing some encryption/decryption (or if you do change it, be sure this object isn't mid decrypt)
`void` `setPreparedKey(java.lang.Object obj)`
`java.lang.String` `toString()`
`void` `writeBytes(java.io.OutputStream out)` Write out the data structure to the stream, using the format defined in the I2P data structure specification.

Methods inherited from class net.i2p.data.DataStructureImpl
`calculateHash, fromBase64, fromByteArray, read, toBase64, toByteArray`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### KEYSIZE_BYTES

    public static final int KEYSIZE_BYTES

See Also:
  Constant Field Values

### INVALID_KEY

    public static final SessionKey INVALID_KEY

Constructor Detail

### SessionKey

    public SessionKey()

### SessionKey

    public SessionKey(byte[] data)

Method Detail

### getData

    public byte[] getData()

### setData

    public void setData(byte[] data)

  caveat: this method isn't synchronized with the preparedKey, so don't try to *change* the key data after already doing some encryption/decryption (or if you do change it, be sure this object isn't mid decrypt)

### getPreparedKey

    public java.lang.Object getPreparedKey()

  retrieve an internal representation of the session key, as known by the AES engine used. this can be reused safely

### setPreparedKey

    public void setPreparedKey(java.lang.Object obj)

### readBytes

    public void readBytes(java.io.InputStream in)
                   throws DataFormatException,
                          java.io.IOException

  Description copied from interface: `DataStructure`
  Load up the current object with data from the given stream. Data loaded this way must match the I2P data structure specification.

  Parameters:
    `in` - stream to read from
  Throws:
    `DataFormatException` - if the data is improperly formatted
    `java.io.IOException` - if there was a problem reading the stream

### writeBytes

    public void writeBytes(java.io.OutputStream out)
                    throws DataFormatException,
                           java.io.IOException

  Description copied from interface: `DataStructure`
  Write out the data structure to the stream, using the format defined in the I2P data structure specification.

  Parameters:
    `out` - stream to write to
  Throws:
    `DataFormatException` - if the data was incomplete or not yet ready to be written
    `java.io.IOException` - if there was a problem writing to the stream

### equals

    public boolean equals(java.lang.Object obj)

### hashCode

    public int hashCode()

### toString

    public java.lang.String toString()